module Authentication
  class InvitationsController < ::ApplicationController
    bmethod :new

    bmethod :create

    def create
      do_create(params, Authentication::Invitation, Proc.new { |context, obj| main_app.root_path}, new_params)
    end
    
    def destroy
      skip_policy_scope
      skip_authorization

      @company = ::Authentication::Company.find(params[:id])
      authorize @company
      @company.destroy

      redirect_to main_app.root_path, alert: 'A projekt sikeresen törölve lett, helyette az első projektje lett kiválasztva!'
    end

    private

    def before_save_create(obj)
      obj.user_id = Current.user.id
      obj.company_id = Current.company.id
    end

=begin    def after_save_create(obj)
      ::Authentication::Company.rights.each do |right|
        Current.user.add_role right, obj
      end
    end
=end
    def new_params
      @object = Invitation.new

      return [ # model properties
        Btemplater::NewDecorator.new(:email, Proc.new { |f, c| f.input :email, autofocus: true, placeholder: t('.email_placeholder') }),
        Btemplater::NewDecorator.new(:user_id, Proc.new { |f, c| f.input :user_id, input_html: { value: Current.user.id }, as: :hidden }),
        Btemplater::NewDecorator.new(:company_id, Proc.new { |f, c| f.input :company_id, input_html: { value: Current.company.id }, as: :hidden })
      ],
      {
        div: 'div',
        div_class: 'underlined-title',
        # back_url: change_company_path(current_user.current_company?),
        obj: [@object],
        # form_pre: 'shared/form_pre',
        # form_post: 'shared/form_post',
        # form_bottom: 'projects/new_project_type', # optional: renders _edit_extradata.html.erb
        # # submit_button_text: 'Submit'
        form_params: {html: { autocomplete: 'off' }}
      }
    end
  end
end
