module Btemplater
  module IndexHelper
    include ApplicationHelper
    include ActionView::Helpers::TagHelper
    include ActionView::Helpers::UrlHelper
    include Btemplater::IndexSubHelper
    include Btemplater::IndexSearchHelper
    include ActionView::Helpers::TagHelper
    include Pundit

    def do_index(args)
      model_name = args[:model].is_a?(Array) ? args[:model].last : args[:model]
      current_user_entity = Current.user # Btemplater::Engine.config.current_user_entity.call(self)
      policy_name = nil
      if args[:policy_class]
        policy_name = "#{args[:policy_class]}Policy".constantize
      else
        policy_name = "#{model_name.to_s}Policy".constantize
      end
      security_items = args[:secupority_items] || args[:class].last
      if args[:auth_method]
        # authorize (security_items), args[:auth_method].to_sym
        raise Pundit::NotAuthorizedError unless policy_name.new(Current, (security_items)).send("#{args[:auth_method]}?")
      else
        # authorize (security_items), :index?
        raise Pundit::NotAuthorizedError unless policy_name.new(Current, (security_items)).index?
      end
      if params[:format] == 'json'
        args[:items].to_json
      elsif params[:format] == 'xml'
        args[:items].to_xml
      else
        # IndexHelper.
        args.merge(
          title: [],
          columns: [],
          items: [],
          model: nil,
          actions: [],
          search: {}
        )
        capture do
          concat(render(args[:form_pre])) if args[:form_pre]
          concat do_title(args[:title], args[:titleactions], args[:title_small], self, args)
          concat(search args[:search], current_user_entity, self)
          concat(paginate args[:items])
          concat(IndexSubHelper.custom_table_for(args, current_user_entity, self) do
                  args[:columns].each do |c|
                    if c.instance_of? Btemplater::IndexDecorator
                      IndexSubHelper.column(c.name, model_name.human_attribute_name(c.name), &c.decorator)
                    elsif c.instance_of? Hash
                      if c.has_key? :date
                        IndexSubHelper.column(c, model_name.human_attribute_name(c[:date]))
                      elsif c.has_key? :date_short
                        IndexSubHelper.column(c, model_name.human_attribute_name(c[:date_short]))
                      end
                    else
                      IndexSubHelper.column c, model_name.human_attribute_name(c)
                    end
                  end
                end)
          concat(paginate args[:items])
          concat(render(args[:table_before_buttons])) if args[:table_before_buttons]
          if args[:newbutton] == true
            if args[:i18n_postfix]
              concat(link_to(I18n.t("helpers.submit.create_#{args[:i18n_postfix]}", model: I18n.t("activerecord.models.#{model_name.name.tableize.singularize}_#{args[:i18n_postfix]}").humanize), polymorphic_url(args[:class].map{|m| m.to_s.demodulize.tableize.singularize}, action: :new), class: 'btn btn-primary'))
            else
              concat(link_to(I18n.t("helpers.submit.create", model: I18n.t("activerecord.models.#{model_name.name.tableize.singularize}")).humanize, polymorphic_url(args[:class].map{|m| m.to_s.demodulize.tableize.singularize}, action: :new), class: 'btn btn-primary'))
            end
          elsif args[:newbutton].is_a?(Hash)
            concat(link_to(args[:newbutton][:title], args[:newbutton][:url], class: args[:newbutton][:class]).html_safe)
          end
          concat(link_to(args[:back_title], args[:back_url], class: 'btn btn-secondary')) if args[:back_url]
          concat(render(args[:optional_urls_partial])) if args[:optional_urls_partial]
          concat(render(args[:table_bottom])) if args[:table_bottom]
          concat(render(args[:form_post])) if args[:form_post]
        end
      end
    end
  end
end
