module Btemplater
  module NewHelper
    # include ApplicationHelper
    # include ActionView::Helpers::TagHelper
    # include ActionView::Helpers::CaptureHelper
    # include SimpleForm::ActionViewExtensions::FormHelper

    def do_new(args)
      model_name = args[:item].is_a?(Array) ? args[:item].last.class : args[:item].class
      if args[:policy_class]
        policy_name = "#{args[:policy_class]}Policy".constantize
      else
        policy_name = "#{model_name.to_s}Policy".constantize
      end
      security_items = args[:security_items] || args[:item]
      if policy_name.blank?
        authorize (security_items), :new?
      else
        skip_authorization
        raise Pundit::NotAuthorizedError unless policy_name.new(Current, security_items).new?
      end

      # raise Pundit::NotAuthorizedError unless policy_name.new(Btemplater::Engine.config.current_user_entity.call(self), security_items).new?
      args.merge(
        title: [],
        columns: [],
        items: [],
        model: nil,
        url: nil,
        method: :get,
        form_bottom: nil,
        flash_success_message: nil,
        form_params: { class: 'form-horizontal' }
      )
      capture do
        concat(render(args[:form_pre])) if args[:form_pre]
        concat do_title(args[:title], nil, args[:title_small], self, args) unless args[:title].blank?
        concat(simple_form_for(args[:item], html: args[:form_params], url: args[:url], post: args[:method]) do |f|
                concat(content_tag(:div, class: 'inputs') do
                                  args[:columns].each do |column|
                                    if column.instance_of? Btemplater::NewDecorator
                                      concat column.decorator.call(f, column)
                                    else
                                      concat f.input column
                                    end
                                  end
                                end)
                    concat(render(args[:form_bottom], f: f)) if args[:form_bottom]
                    concat(content_tag(:div, class: 'actions') do
                                          if args[:submit_button_text] == false
                                          elsif !args[:submit_button_text].nil?
                                            concat f.submit args[:submit_button_text], class: 'btn btn-primary'
                                          else
                                            concat f.submit I18n.t('btemplater.actions.new', model: f.object.model_name.human).humanize, class: 'btn btn-primary'
                                          end
                                          concat link_to t('cancel', scope: :btemplater), args[:back_url], class: 'btn btn-secondary' unless args[:back_url] == false
                                        end)
                end)
        concat(render(args[:form_post])) if args[:form_post]
      end
    end

    module_function :do_new
  end
end
