module Btemplater
  module ShowHelper
    def do_show(args)
      raise Pundit::NotAuthorizedError unless "#{args[:model]}Policy".constantize.new(Btemplater::Engine.config.current_user_entity.call(self), args[:item]).show?
      args.merge(
        title: [],
        columns: [],
        item: nil,
        model: nil,
        url: nil
      )

      skip_policy_scope

      innercontent = ''
      args[:actions].each do |action|
        if action == :separator
          innercontent = innercontent + '<span class="btn-separator"></span>'.html_safe
        else
          innercontent = innercontent + action.html_safe
        end
      end if args[:actions]

      capture do
        concat do_title(args[:title], nil, args[:title_small], args) #unless args[:title]
        unless args[:columns].nil?
          concat(
            show_for(args[:item]) do |s|
              args[:columns].each do |column|
                if column.instance_of? Btemplater::ShowDecorator
                  if column.block.nil?
                    concat(s.attribute column.name, column.arguments)
                  else
                    concat(s.attribute(column.name, column.arguments) do
                      column.block.call(s.object.send(column.name))
                    end)
                  end
                else
                  # concat(s.label column)
                  concat(s.attribute column)
                end
              end if args[:columns]
            end
          )
        end
        concat(
          if args[:my_content]
            render args[:my_content]
          end
        )

        concat(
          content_tag(:div, class: 'actions') do
            concat link_to(t('actions.back', scope: :btemplater), args[:url] || :back, class: 'btn btn-primary') unless(args[:no_back])
            if args[:action_outerdiv_options]
              concat content_tag(:div, innercontent.html_safe, args[:action_outerdiv_options])
            else
              concat innercontent.html_safe
            end
          end
        )
      end
    end
  end
end
