module Authentication
  class Invitation < ApplicationRecord
    after_create :send_invitation

    validates :user_id, uniqueness: { scope: [:email, :company_id] }

    private

    def send_invitation
      user = User.where(email: self.email).try(:first)
      if user
        user.check_invitations
        Authentication::InvitationMailer.right_added_to_user(self).deliver_now
      else
        Authentication::InvitationMailer.invite_user(self).deliver_now
      end
    end
  end
end
