# frozen_string_literal: true

#
# The template magic
#
module Btemplateable
  def self.included(host_class)
    host_class.include Btemplater::SuperHelper

    host_class.helper ActionView::Helpers::SanitizeHelper

    host_class.helper Btemplater::ApplicationHelper
    host_class.helper Btemplater::IndexHelper
    host_class.helper Btemplater::IndexSubHelper
    host_class.helper Btemplater::NewHelper
    host_class.helper Btemplater::EditHelper
    host_class.helper Btemplater::ShowHelper
    host_class.include Btemplater::Tools

    host_class.extend ClassMethods

    def bauth(&block)
      if block_given?
        yield
      else
        if [:show].include?(@b_templateable_name.to_sym)
          # @bug = Bug.find(params[:id])
        end
        klass = self.class.name.to_s.downcase.split('controller').first.singularize.to_sym
        authorize klass, "#{@b_templateable_name.to_sym}?"
      end
    end

    def bscope(&block)
      if block_given?
        yield
      else
        skip_policy_scope
      end
    end

    def bload(&block)
      yield
    end
  end
  # extend ActiveSupport::Concern

  module ClassMethods
    def bmethod(name, config = {}, &block)
      if name == :new && !block_given?
        define_method :new do
          render inline: supernew(
            new_params[0],
            new_params[1],
            view_context
          ), layout: true
        end
      elsif name == :show && !block_given?
        define_method :show do
          skip_policy_scope
          @object = self.class.name.split('Controller').first.singularize.constantize.find(params[:id])
          authorize @object
          obj = self.class.name.split('Controller').first.singularize.constantize
          path = self.class.name.split('Controller').first.downcase.gsub('::', '.') + '_path'
        end
      elsif name == :showtable && !block_given?
        define_method :show do
          skip_policy_scope
          @object = self.class.name.split('Controller').first.singularize.constantize.find(params[:id])
          authorize @object, :show?
          obj = self.class.name.split('Controller').first.singularize.constantize
          path = self.class.name.split('Controller').first.downcase.gsub('::', '.') + '_path'
          render 'btemplater/shared/showtable', locals: { config: config }
        end
      elsif name == :create && !block_given?
        define_method :create do
          obj = self.class.name.split('Controller').first.singularize.constantize
          path = self.class.name.split('Controller').first.downcase.gsub('::', '.') + '_path'
          do_create(params, obj, send(path.split('.').first).send(path.split('.').last), new_params)
        end
      elsif name == :edit && !block_given?
        define_method :edit do
          @object = self.class.name.split('Controller').first.singularize.constantize.find(params[:id])

          render inline: superedit(
            edit_params[0],
            edit_params[1],
            view_context
          ), layout: true
        end
      elsif name == :update && !block_given?
        define_method :update do
          obj = self.class.name.split('Controller').first.singularize.constantize
          path = self.class.name.split('Controller').first.downcase.gsub('::', '.') + '_path'
          do_update(params, obj, send(path.split('.').first).send(path.split('.').last), edit_params)
        end
      elsif name == :destroy && !block_given?
        define_method :destroy do
          obj = self.class.name.split('Controller').first.singularize.constantize
          path = self.class.name.split('Controller').first.downcase.gsub('::', '.') + '_path'
          puts obj.inspect
          puts path.inspect
          skip_policy_scope
          do_destroy(params, obj, send(path.split('.').first).send(path.split('.').last))
          # @object = self.class.name.split('Controller').first.singularize.constantize.find(params[:id])
          # authorize @object
          # obj = self.class.name.split('Controller').first.singularize.constantize
          # path = self.class.name.split('Controller').first.downcase.gsub('::', '.') + '_path'
          # LastVisitedProject.where(company_id: current_user.current_company?.id, project_id: @project.id).try(:destroy_all)
          # @object.destroy
          # redirect_to send(path.split('.').first).send(path.split('.').last)
        end
      else
        define_method name do
          @b_templateable_name = name
          instance_eval &block
        end
      end
    end

    # def configg
    #   @config ||= Configuration.new
    # end

    # def configure
    #   yield config
    # end
  end

  # class Configuration
  #   attr_accessor :method_name, :context
  # end
end
