# frozen_string_literal: true

#
# The timezone part of Application Controller
#
module Btemplater::Zoneinfo
  extend ActiveSupport::Concern
  
  included do
    unless Rails.env == 'development'
      around_action :user_time_zone, if: :current_user
    end

    def user_time_zone(&block)
      Time.use_zone(current_user_time_zone, &block)
    end

    def current_user_time_zone
      Current.user.try(:timezone).try(:blank?) ? Time.zone.name : Current.user.try(:timezone)
    end
  end
end
