# frozen_string_literal: true

#
# The singleton
#
class Current < ActiveSupport::CurrentAttributes
  attribute :user, :company, :request_id, :user_agent, :ip_address, :params, :timezone, :language

  def to_myhash
	return {
		user_id: user.try(:id),
		company_id: company.try(:id),
		request_id: request_id,
		user_agent: user_agent,
		ip_address: ip_address,
		params: params.to_unsafe_h,
		timezone: timezone,
		# TODO: Rails 6-nál vissza lehet írni
		# language: language
		language: language.to_s
	}
  end

  def from_hash(hsh)
  	tmpCurrent = Current.clone
  	tmpCurrent.user = Authentication::User.find(hsh[:user_id])
  	tmpCurrent.company = Authentication::Company.find(hsh[:company_id])
  	tmpCurrent.request_id = hsh[:request_id]
  	tmpCurrent.user_agent = hsh[:user_agent]
  	tmpCurrent.ip_address = hsh[:ip_address]
  	tmpCurrent.params = ActionController::Parameters.new(hsh[:params])
  	tmpCurrent.timezone = hsh[:timezone]
  	# TODO: Rails 6-nál nem kell a to_sym
  	tmpCurrent.language = hsh[:language].try(:to_sym)
  	return tmpCurrent
  end
end