module Authentication
  class CompanyPolicy < ::ApplicationPolicy
    class Scope < Scope
      def users_companies
        return Current.user.companies.select { |c| Current.user.has_role?(:member, c)}
      end
    end

    def index?
      !Current.user.nil?
    end

    def show?
      !Current.user.nil? && !@record.nil? && Current.user.has_role?(:member, @record)
    end

    def new?
      !Current.user.nil?
    end

    def create?
      new?
    end

    def edit?
      !Current.user.nil? && !@record.nil? && Current.user.has_role?(:admin, @record)
    end

    def update?
      edit?
    end

    def destroy?
      edit?
    end

    def change?
      !Current.user.nil? && !@record.nil? && (Current.user.has_role?(:admin, @record) || Current.user.has_role?(:member, @record) || @record.user == Current.user)
    end

    def permitted_attributes
      [
        :name
      ]
    end
  end
end